'' ==================================================================
''
''   File....... jm_sircs_rx_demo.spin
''   Purpose.... SIRCS receiver
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''   E-mail..... jon@jonmcphalen.com
''   Started.... 
''   Updated.... 21 JUL 2009
''
'' ==================================================================
CON

  _clkmode  = xtal1 + pll16x
  _xinfreq  = 5_000_000


'' PST formmatting control 
  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS 
 


OBJ

  ir   : "jm_sircs_rx"                '' sircs decoding 
''  term : "jm_txserial"               '' tx serial 
  term : "Parallax Serial Terminal"

PUB Start
  term.Start(115200) ' term on programming port
''  waitcnt(clkfreq / 1_000 + cnt) 
  main

PUB main | code, bc

  ir.init(9)                          ' IR demod HIB on p8

  term.Char(CLS)
  term.str(string("SIRCS Sniffer [PASM]"))
  term.Char(CR)

  repeat
    code := ir.getir                    ' wait for key
    bc := ir.bitcount                   ' get bitcount
    case bc
      12:
        term.str(string("12 :: "))       ' show bit count
        term.bin(code >> 7, 5)           ' show device code
        term.Char(".")                     ' separater
        term.bin(code, 7)                ' show key code
      15:
        term.str(string("15 :: "))
        term.bin(code >> 7, 8)
        term.Char(".")
        term.bin(code, 7)
      20:
        term.str(string("20 :: "))
        term.bin(code >> 12, 8)
        term.Char(".")
        term.bin(code, 12)
      other:
        if bc < 10
          term.Char("0")
        term.dec(bc)
        term.str(string(" :: "))
        term.bin(code, 32) 
    term.Char(CR)    
    waitcnt(clkfreq / 4 + cnt)

